const cheerio = require('cheerio');
// const HeadlessChrome = require('simple-headless-chrome-asksuite');
const puppeteer = require('puppeteer');



// const browser = new HeadlessChrome({
//     headless: true, // If you turn this off, you can actually see the browser navigate with your instructions
//     chrome: options
// });


async function navigateWebsite(url, idHotel, checkin, checkout, adultos, criancas) {

    const browser = await puppeteer.launch({headless: true, args: ['--no-sandbox', '--disable-setuid-sandbox']});
    try {

        const mainTab = await browser.newPage();

        // Document, Stylesheet, Image, Media, Font, Script, TextTrack, XHR, Fetch, EventSource, WebSocket, Manifest, Other.
        await mainTab.setRequestInterception(true);
        mainTab.on('request', request => {
            if (request.resourceType() === 'image' || request.resourceType() === 'font' || request.resourceType() === 'stylesheet' ) {
                request.abort();
            }
            else {
                request.continue();
            }

        });


        if (criancas && criancas === '0') {
            criancas = '';
        }

        let urlBuild = `${url}/D/Reserva?checkin=${checkin}&checkout=${checkout}&cidade=&hotel=${idHotel}&adultos=${adultos}&criancas=${criancas}&promocode=&tarifa=`;

        console.log(urlBuild);

        await mainTab.goto(urlBuild, {timeout: 20000})
        await mainTab.waitForSelector('#acomodacoesWrapper', {timeout: 20000})


        const htmlTag = await mainTab.evaluate(function (selector) {
            const selectorHtml = document.querySelector(selector)
            return selectorHtml.innerHTML
        }, '#content'); // returns innerHTML of first matching selector for class "main"

        //    console.log(htmlTag.result.value);

        let $ = cheerio.load(htmlTag);
        let promise = null;

        if ($('#hotel-selecionado-indisponivel-titulo').text() != "") {

            console.log("erro");

            let obj = {
                message: $('#hotel-selecionado-indisponivel-titulo').text()
            };

            promise = await Promise.reject(obj)


        } else {

            let rooms = [];

            $('.row-quarto').each((index, item) => {

                let room = new HotelRoom();

                // console.log( $(item).children().length)

                $(item).children().each((index, td) => {


                    if (index == 0) {

                        let tdx = $(td);

                        room.name = tdx.find('.quartoNome').text()
                        room.mainPhoto = tdx.find('.imgQuarto').attr('src');
                        room.description = tdx.find('.quartoDescricao').find('p').text()
                        room.amountAdults = tdx.find('.adultos').attr('data-n');
                        room.amountKids = tdx.find('.criancas').attr('data-n');

                        if (room.amountKids == 'no') {
                            room.amountKids = 0;
                        }

                        let str = tdx.find('.imgQuarto').attr('onclick');

                        let idStr = str.replace(/[^0-9,]/g, "").split(",");

                        room.id = idStr[1];


                        let modalMoreInfo = $('#modal-container-' + room.id);

                        modalMoreInfo.find('.amenities-list > .amenity-item').each((index, itemAmenite) => {
                            room.amenites.push($(itemAmenite).text());
                        })


                        modalMoreInfo.find('#divGaleria > img').each((index, itemAmenite) => {
                            room.images.push($(itemAmenite).attr('src-full-image'));
                        })


                    } else {


                        let tdx = $(td);

                        room.price = tdx.find('.valorFinal').first().text();
                        room.total = 'R$ ' + tdx.find('.var-cart-valor-total').val() + ",00";
                    }

                    // console.log("td", room)
                })

                let obj = {
                    data: rooms,
                    url: urlBuild,
                };
                rooms.push(room)

                console.log(rooms);

                promise = Promise.resolve(obj)
            })


        }


        // Close the browser
        await browser.close()


        return promise;

    } catch (err) {
        console.log(err);
        await browser.close()
        throw err;
    }
}

//
// navigateWebsite('https://gjphotels.letsbook.com.br', 26, '14/05/2018', '15/05/2018', 2, 0).then(data => {
//     console.log("sucesso")
// }).catch(error => {
//     console.log("caiu aqui");
//     console.log(error.message);
// });

class HotelRoom {

    constructor() {
        this.amenites = new Array();
        this.images = new Array();
    }

}


module.exports = {search: navigateWebsite}



